// DirectDraw.cpp: implementation of the CDirectDraw class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Direct.h"
#include "DirectDraw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDirectDraw::CDirectDraw()
{
lpDD=NULL;
PrimarySurf=NULL;
SecondarySurf=NULL;
memset(&strsurf,0,sizeof(DDSURFACEDESC));
strsurf.dwSize = sizeof(DDSURFACEDESC);

}

CDirectDraw::~CDirectDraw()
{
lpDD->RestoreDisplayMode();
lpDD->SetCooperativeLevel(0,DDSCL_NORMAL );  
if (SecondarySurf!=NULL) SecondarySurf->Release(); 
if (PrimarySurf!=NULL) PrimarySurf->Release();	
if (lpDD!=NULL) lpDD->Release();
}

BOOL CDirectDraw::InitDirectDraw()
{
rezult = DirectDrawCreate(NULL, &lpDD, NULL );
if( rezult != DD_OK )  return FALSE;
return TRUE;
}

BOOL CDirectDraw::GetFullScreenCooperativeLevel()
{
if (lpDD->SetCooperativeLevel(AfxGetMainWnd()->GetSafeHwnd(),DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN )!=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::SetMode640_480_8()
{
if (lpDD->SetDisplayMode(640,480,8) !=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::CreatePrimarySurf()
{
strsurf.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT; 
strsurf.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX; 
strsurf.dwBackBufferCount = 1;
if (lpDD->CreateSurface(&strsurf,&PrimarySurf,NULL) !=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::GetSecondarySurf()
{
strsurfsec.dwCaps = DDSCAPS_BACKBUFFER;
if (PrimarySurf->GetAttachedSurface(&strsurfsec,&SecondarySurf)!= DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::ClearSurfSecond()
{
//memset(&DdsdSecond,0,sizeof(DDSURFACEDESC));
//DdsdSecond.dwSize = sizeof(DDSURFACEDESC);
//if (SecondarySurf->Lock(NULL,&DdsdSecond,DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR,NULL)!=DD_OK) return FALSE;

    //      ,  
  //  char* buf = (char*)DdsdSecond.lpSurface;
//	memset(buf,0,(DdsdSecond.dwHeight * DdsdSecond.dwHeight)); 
    //
    
//if (SecondarySurf->Unlock(NULL)!=DD_OK) return FALSE; 
	CRect rect;
     rect.top = 0;
     rect.left = 0;
     rect.right = 640;
     rect.bottom = 480;


return ImageToSurface(SecondarySurf,IDB_BITMAP1,rect,0,0);

}

BOOL CDirectDraw::Flips()
{
if (PrimarySurf->Flip(NULL,DDFLIP_WAIT) !=DD_OK) return FALSE; 
return TRUE;
}

BOOL CDirectDraw::ImageToSurface(LPDIRECTDRAWSURFACE sr, long rID,CRect rect,int x,int y )
{
	HANDLE hBMP;
	HDC     hdc;
	hBMP=LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(rID) , IMAGE_BITMAP, 0, 0,  LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
	if (hBMP == NULL) return FALSE;
	rezult = sr->GetDC(&hdc);
	if(rezult!=DD_OK) return FALSE;

    HDC hCompt = CreateCompatibleDC(hdc);
	SelectObject(hCompt,hBMP);
	BitBlt(hdc, rect.top  ,rect.left ,rect.right  , rect.bottom  , hCompt, 0, 0, SRCCOPY);

	sr->ReleaseDC(hdc);  
	return TRUE;
}

BOOL CDirectDraw::CreateOffScreen1Surf()
{
	DDSURFACEDESC offscr;
	memset(&offscr,0,sizeof(DDSURFACEDESC));
	offscr.dwSize = sizeof(DDSURFACEDESC);
	offscr.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	offscr.ddsCaps.dwCaps  = DDSCAPS_OFFSCREENPLAIN;
	offscr.dwHeight = 240;
	offscr.dwWidth = 100;
	if (lpDD->CreateSurface(&offscr,&offscr1,NULL) !=DD_OK) return FALSE;
	CRect rect;
	rect.top =0;
	rect.bottom = 240;
	rect.left = 0;
	rect.right = 100;
	return ImageToSurface(offscr1,IDB_BITMAP2,rect,0,0);
}
